# <div align="center"> weiz*PVP*: **README** </div>

<div align="center">

Addon hosted on: [**Curse**](https://wow.curseforge.com/projects/weizpvp) *and* [**WoW Interface**](https://www.wowinterface.com/downloads/info24779-weizPVP.html)

![weizPVP Logo](https://i.imgur.com/Kmp7bt7.png)

----

![weizPVP Screenshot 1](https://i.imgur.com/pTZxxmS.png) 
> *Screenshot showing the main window with crosshairs enabled.*


</div>
<div align="left">

----

### :package: 1.71-beta1

**DEV NOTES**
- I've been resetting my options and player database quite often due to test so I may not have noticed any issues from previous versions.
  - If you find any issues, you can try running the command: `/wpvp resetOptions` to wipe just the options, but not the player data.
  - If you still have problems you can wipe **ALL** your weizPVP settings and player data with `/wpvp resetall` which will make it as if you just installed it for the first time.
- If you want to help find bugs easy, feel free to use *debug mode*, which will detect **ALL** players; hostile as well as friendly.
  - You can toggle it back off by running the command again.
  - The status bar will also show 'DEBUG

**INTERFACE & DESIGN**
- You are now able to change the sound file for player detected and stealth alert events
  - Additional sound files have been added to choose from.
  - Sounds from other addons using the ShardMedia library will also be shown, so there should be a lot to choose from!

**CODE & BACKEND**
- Several optimizations resulting in less CPU and memory usage.
- LagMode options adjusted for better reduction in processing when enabled and active.
- Improved the role detection further by adding in some more spellIDs and Auras.
- Roles are now updated as soon as it's known what it is.
  - *Previous versions only updated between sightings; now the player can change specs while on the list and you'll see the update once we have a know spell/ability to go off of.*
  - 360+ different spells, abilities, and auras are now being used to determine the role of the player.
    - This isn't 100% coverage of the roles, but it should is being determined quickly due to spell/ability rotations and auras gained.
    - If you want something added that isn't in yet that you noticed, just post an issue on the weizPVP page on Curse and I'll add it in.

----

### :package: 1.70 

**CODE & BACKEND**
- Many option issues fixed. Should now be setting and updating properly.
- Managing player data improved greatly; now using less resources and smarter sorting.
- A few improvements to role detection
  - Roles, when determined, are left active for a few minutes until checking for an update in order to reduce constant processing of data that doesn't change often. 
  - Roles are now saved in the DB and recalled when a player is detected again, using first the last known spec until otherwise determined.
- Improved dealing with dead players in a few more situations.

**INTERFACE & DESIGN**
- Resolved some issues related to the Crosshairs; should be working properly now.
  - *Blizzard seems to have changed some things related nameplates and as a result crosshairs were not working 100%.*
- Sorting methods polished and includes smarter updating and display of players on the list.
  - *Nothing drastic and most players probably won't even notice the change, but will work better when dealing with large groups.*
- Options are now more organized and better formatted.

----

### :package:  1.68

**CODE & BACKEND**
- Recreated the main combat log parsing function to be more efficient with determining information and using less processing and memory usage at the same time.
  - Significantly less processing during combat log events.
  - Optimized even further for players that are already listed.
  - Added LagMode optimizations, if enabled; this will stop guessing level estimations and other data-gathering functions to focus more on player's health and death events.
- Option changes:
  - LagMode is disabled by default.
  - Enabled in battlegrounds is now true by default
- Fixed one issue related to sorting dead players properly but there seems to be another issue with sorting them, but not all the time.
  - It's being looked into and it's a pretty minor bug overall.
- "LagMode" updates:
  - More places where LagMode disables info gathering methods that are more CPU intensive when LagMode is enabled and below FPS threshold (See options for details)

**INTERFACE & DESIGN**
- Crosshair updates
  - Crosshairs should now properly show _behind_ nameplates, as not to cover up the name or interfere with 3d party addons placing additional elements on the bar.
  - Optimized the animating of the crosshairs when switching targets and should also look cleaner and smoother.

----

### :package:  1.65

**CODE & BACKEND**
- Improved role detection by checking out player auras as well as spells and abilities used.

----

### :package:  1.6

**INTERFACE & DESIGN**
- Stealth Alert changes
  - Class color now added.
  - Ability name added.
  - More stealth abilities and items added to detection:
    - Greater Invisibility
    - Mass Invisibility
    - Shroud of Concealment
    - Stealthman 52
- Options Updated
  - Better grouping of options.
  - Enable in Arena option added.
  - Added stealth detection options for display and sound under Alerts section.
  - BETA section added for BETA Options.
    - LagMode options added to BETA section.
      - Enable toggle.
      - FPS threshold; Enables LagMode when below this level.

**CODE & BACKEND**
- Optimizations in a number of spots; Small CPU and memory reductions.
- Player info gathering optimized greatly; Large CPU reduction.
- DB Updates to get ready for Kill on Sight coming in 2.0.
- Combat Log and Health events/data collection changes:
  - Updated some methods of obtaining data.
  - Less CPU/mem usage.
- Library changes.
  - LibRangeCheck updated.
  - LibCLHealth removed.

----

### :package:  1.54

**CODE & BACKEND**
- Optimizations in the data gathering functions for detected players.
  - Mostly memory usage reductions.

----

### :package:  1.53

**CODE & BACKEND**
- Fixed another potential area where the player bars could flicker/swap with other players.
  - This fix made it easier to reduce even more processing by properly targeting single bars for updates.
  - This, along with other fixes have led to the lowest CPU and mem usage yet for weizPVP.
- Continued to optimize events and the processing of unit data to run even better in heavy PVP.

----

### :package:  1.52

**CODE & BACKEND**
- Fixed a few small bugs making player bars jump around a bit.
- More optimization here and there.

----

### :package:  1.51

**CODE & BACKEND**
- Some more optimizations;
  - List and player bar updates reduced further to be ran only when needed for visual updates.
  - Reduced running _some_ functions to gather player data when we already have it; we just update the timestamp/last seen info.
    - This will be an ongoing process. The addon is only getting faster at this point, even with new features added.
- Fixed a bug that was creating warnings while entering new zones.

**INTERFACE & DESIGN**
- Small adjustments to transition animation of the crosshairs.

----

### :package:  1.5

**CODE & BACKEND**
- Fixed some more bugs related to crosshairs not always showing up properly in a variety of situations.
- Big Database changes;
  - All previous options (like.. 5?) will be reset to the current default. (Last time this should happen)
  - Some optimizations made in the way it functions.
  - Better and more efficient structure.
- Multiple optimizations related to updating the player lists and bars; both data and the status bars.
  - CPU and Memory usage _looks_ to be down about 30-50% overall. More optimizations to come!

**INTERFACE & DESIGN**
- Crosshairs will now do a better job of staying on a nameplate after reaching it.
  - This also turned out to be a pretty nice optimization as well.

**FUNCTIONALITY**
- Slash commands have been simplified more since more and more are going to WoW's option menu.
- Fixed some weird issues with the crosshair acting oddly via options or in BGs.
- Fixed problems with when toggle BGs on or off while in them.

----

### :package:  1.22

**CODE & BACKEND**
- Fixed a number of bugs while looking into sorting issues.
  - Sorting issues out of combat seem resolved.

----

### :package:  1.2

**INTERFACE & DESIGN**
- Adjusted Crosshair some animations and textures.

**CODE & BACKEND**
- Cleaned up assets and old comments for release.
- Optimized some code dealing with list management.

----

### :package:  1.13

**INTERFACE & DESIGN**
- Minor changes to bar textures.

**FUNCTIONALITY**
- Addressed Issue #13 on Curseforge: Pinning options are now synced across methods (slash, right click, interface options).
- Slash commands for lock and pin now toggle on/off.
  - The 'unpin' and 'unlock' slash commands removed as there is one command to toggle them.

----

### :package:  1.12

**INTERFACE & DESIGN**
- Added an indicator to the player bars to show your target.
- Added small animation effects to min/max button.
- Resizing the main window will now snap at heights that show only complete bars. No more cutoff bars; Perfection.
- Clamping of the window to the screen has been improved. No part of the window should be able to be moved off-screen anymore.
- Scrolling now correctly scrolls in even increments based on the size and spacing of the player bars.
- Right-Clicking on the title bar at the top of the addon addon will now toggle the 'pin' option, and will output in chat to let you know as well.
- Window location and size is now saved between sessions.

**FUNCTIONALITY**
- The addon is now disabled in all instances (even BGs and Arenas). This may change later, but in order to have it work properly a decent big of work is required as they use additional API calls specific to the instance.


</div>
