-------------------------------------------------------------------------------
--|> Display
-- Holds functions relations to the display (resolution, fps, events, etc)
-------------------------------------------------------------------------------
--|> UPVALUE GLOBALS
-------------------------------------------------------------------------------
local weizPVP = weizPVP

-------------------------------------------------------------------------------
--|> FUNCTIONS
-------------------------------------------------------------------------------

--=> SCALE COORDS
--> IN: X,Y coords of where to place something
--> OUT: X, Y coords based effective scale of the game window.
-------------------------------------------------------
local xFactor
local yFactor
local x, y
function weizPVP.ScaleCoords(xPixel, yPixel)
	xFactor = weizPVP.Display.xFactor
	yFactor = weizPVP.Display.yFactor
	x, y = xPixel / xFactor, yPixel / yFactor
	x, y = x - x % 1, y - y % 1
	return x * xFactor, y * yFactor
end

--=> EVENT: DISPLAY SIZE CHANGED
--> UPDATE DISPLAY DATA
-------------------------------------------------------
function weizPVP:UpdateDisplayData()
	weizPVP.Display.Width = GetScreenWidth()
	weizPVP.Display.Height = GetScreenHeight()
	weizPVP.Display.xFactor = (768 / weizPVP.Display.Width) * (weizPVP.Display.Width / weizPVP.Display.Height)
	weizPVP.Display.yFactor = 768 / weizPVP.Display.Height
	weizPVP.Display.UIScale = UIParent:GetScale()
	weizPVP.Display.EffectiveScale = UIParent:GetEffectiveScale()
end
